
public class CGQueue {
	
	// the text before the letter in the announcing of having picked up a letter.
	final private static String PICKED_UP	= "Poimittu:";
	
	final private static CGLetter EMPTY	= new CGLetter();
	
	public CGLetterSlot slot;
	private CGLetter letter;

	final private CrosswordGame game;
	public CGQueue(final CrosswordGame g) {
		game = g;
		slot = null;
		letter = null;
	}
	public void set(final CGLetterSlot s) {
		slot = s;
		letter = s.getLetter();
	}
	public void unset() {
		if ( (slot != null) && (letter != null) )	slot.setLetter(letter);
		clear();
	}
	public void clear() {
		slot = null;
		letter = null;
	}
	public void swap(final CGLetterSlot s) {
		
		// a pickup.
		if (slot == null) {
			set(s);
			letter = s.getLetter();
			s.setLetter(EMPTY);
			if (s instanceof CGCell)	((CGCell) s).unHighlight();
			game.setStatus(PICKED_UP + " " + letter.toString());
			return;
		}
		
		// a genuine swap.
		else {
			slot.setLetter(s.getLetter());
			if (slot instanceof CGCell)	((CGCell) slot).highlight();
			s.setLetter(letter);
			if (s instanceof CGCell)	((CGCell) s).highlight();
			clear();
		}
	}
	public CGLetter get() {
		if (slot == null)	return new CGLetter();
		else {
			CGLetter outOfQueue = letter;
			clear();
			return outOfQueue;
		}
	}
	public boolean isCell() {
		return (slot instanceof CGCell);
	}
	public boolean isEmpty() {
		return (slot == null);
	}
}
