import java.io.IOException;
import java.io.InterruptedIOException;

import org.eclipse.swt.SWTException;
import org.eclipse.swt.widgets.Display;



// this class, the ugliest of the ugly, listens to the opponent's moves,
// implementing them until (s)he passes the turn to the local player.
public class CGWaiter implements Runnable {
	
	final private static String LOCAL_PLAYERS_TURN_STATUS	= "Sinun vuorosi.";
	
	// whether applying the move failed.
	private boolean moveFailed = false;

	
	
	// the constructor sets the parent game.
	final private CrosswordGame game;
	public CGWaiter(final CrosswordGame g) {
		game = g;
	}
	
	public void run() {
		String move = "";
			
		try {
			try {
				try {
					do {
							move = "";
		    				while (move.equals("")) {
		    					try {
		    						move = game.connection.readLine();
		    					}
		    					catch (InterruptedIOException ex) {
		    						move = "";
		    					}
		    					if (!game.actionButtons.connecting) {
		    			        	Display.getDefault().asyncExec(new Runnable() {
		    			        		public void run() {
		    			        			try {
		    			        				game.disconnected(CrosswordGame.DISCONNECTED);
		    			        			}
		    			        			
		    		        				// if this happens, we're dead already.
		    		        				catch (SWTException ex) {
		    		        					System.exit(0);
		    		        				}
		    				    		}
		    				    	});
		    			        	return;
		    					}
		    				}
			
		    		    	MoveApplier applier = new MoveApplier(move);
		    		    	Display.getDefault().syncExec(applier);
						
		    		    	if (moveFailed) {
			    				game.connection.writeLine(CGProtocol.MOVE_FAILED);
			    				throw new IOException();
		    		    	}
		    				game.connection.writeLine(CGProtocol.MOVE_RECEIVED);
		    				 
		    				if (CGMove.getMoveType(move).equals(CGProtocol.MOVE_TYPES_SWAP))
		    					break;
		    				
		    				if (CGMove.getMoveType(move).equals(CGProtocol.MOVE_TYPES_FIX))
		    					break;
		    				
		    				if (CGMove.getMoveType(move).equals(CGProtocol.MOVE_TYPES_UNDOFIX))
		    					break;
		    				
				    } while ( !(move.equals("")) );
					
			    	Display.getDefault().asyncExec(new Runnable() {
			    		public void run() {
			    			try {
								game.enable();
								
					    		// disable 'Swap' if out of alphabet.
					    		// enable 'Swap' if alphabet available.
					    		if ( (game.alphabet.size() > 0) )	game.actionButtons.enableSwap();
					    		else								game.actionButtons.disableSwap();

								game.blink();
								game.setStatus(LOCAL_PLAYERS_TURN_STATUS);
			    			}
			    			
	        				// if this happens, we're dead already.
	        				catch (SWTException ex) {
	        					System.exit(0);
	        				}
			    		}
			    	});
				}
				catch (NullPointerException ex) {
					throw new IOException();
				}
				
			}
		    catch (IOException e) {
		    	try {
		        	Display.getDefault().asyncExec(new Runnable() {
		        		public void run() {
		        			try {
		    					if (!game.actionButtons.connecting) {
		    			        	Display.getDefault().asyncExec(new Runnable() {
		    			        		public void run() {
		    			        			try {
		    			        				game.disconnected(CrosswordGame.DISCONNECTED);
		    			        			}
		    			        			
		    		        				// if this happens, we're dead already.
		    		        				catch (SWTException ex) {
		    		        					System.exit(0);
		    		        				}
		    				    		}
		    				    	});
		    			        	return;
		    					}
		    					else			game.disconnected();
		        			}
		        			
	        				// if this happens, we're dead already.
	        				catch (SWTException ex) {
	        					System.exit(0);
	        				}
		        		}
		        	});
					return;
		    	}
				catch (NullPointerException ex) {
					;
				}
		    }
		}
		
		// if this happens, we're dead already.
		catch (SWTException ex) {
			System.exit(0);
		}
	}
	
	
	
	private class MoveApplier implements Runnable {
		private String move;
		
		private MoveApplier(String m) {
			move = m;
		}
		public void run() throws NullPointerException, SWTException {
			if (move == null)	moveFailed = true;
			if ( !(game.connection.executeMove(move)) )	moveFailed = true;
		}    
	}
}
